#include "pga.h"
#include "stm32f0xx.h"
#include "buzzer.h"

extern void Delay(volatile unsigned int cycles);


__INLINE void Configure_GPIO_SPI1(void)
{
  /* Enable the peripheral clock of GPIOA */
  RCC->AHBENR |= RCC_AHBENR_GPIOAEN;
	
	GPIOA->MODER |= GPIO_MODER_MODER5_0;
	GPIOA->MODER |= GPIO_MODER_MODER7_0;
}


__inline void ClkH(void)
{
  GPIOA->BSRR = GPIO_Pin_5;	
}
__inline void ClkL(void)
{
  GPIOA->BRR = GPIO_Pin_5;	
}

__inline void DataH(void)
{
  GPIOA->BSRR = GPIO_Pin_7;	
}
__inline void DataL(void)
{
  GPIOA->BRR = GPIO_Pin_7;	
}


void pga_init(void) {
	/* Enable the peripheral clock of GPIOB */
	RCC->AHBENR |= RCC_AHBENR_GPIOBEN;	
	
	// CS pin
	GPIOB->MODER |= GPIO_MODER_MODER1_0;
	// set CS high
	GPIOB->BSRR = GPIO_Pin_1;	

	Configure_GPIO_SPI1();
	
	ClkL();
	DataL();
	
	//Beep();
}

__inline void BitDelay(void) {
	Delay(100);
}

static void send_byte(unsigned char val) {
	int i;
	for (i=0; i<8; i++) {
		if (val & 0x80) {
			DataH();
		} else {
			DataL();
		}
		BitDelay();		
		ClkH();
		BitDelay();
		ClkL();
		val <<= 1;
	}
}

/* 0x40 + gain */
void pga_set(unsigned char gain) {	
	Beep();
	
	// clear CS
	GPIOB->BRR = GPIO_Pin_1;

	send_byte(0x40);
	send_byte(gain);
	
	// set CS
	GPIOB->BSRR = GPIO_Pin_1;	
}

